package com.lightinit.hsdatashow.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class StWaterLakeExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public StWaterLakeExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andRegionIdIsNull() {
            addCriterion("region_id is null");
            return (Criteria) this;
        }

        public Criteria andRegionIdIsNotNull() {
            addCriterion("region_id is not null");
            return (Criteria) this;
        }

        public Criteria andRegionIdEqualTo(Long value) {
            addCriterion("region_id =", value, "regionId");
            return (Criteria) this;
        }

        public Criteria andRegionIdNotEqualTo(Long value) {
            addCriterion("region_id <>", value, "regionId");
            return (Criteria) this;
        }

        public Criteria andRegionIdGreaterThan(Long value) {
            addCriterion("region_id >", value, "regionId");
            return (Criteria) this;
        }

        public Criteria andRegionIdGreaterThanOrEqualTo(Long value) {
            addCriterion("region_id >=", value, "regionId");
            return (Criteria) this;
        }

        public Criteria andRegionIdLessThan(Long value) {
            addCriterion("region_id <", value, "regionId");
            return (Criteria) this;
        }

        public Criteria andRegionIdLessThanOrEqualTo(Long value) {
            addCriterion("region_id <=", value, "regionId");
            return (Criteria) this;
        }

        public Criteria andRegionIdIn(List<Long> values) {
            addCriterion("region_id in", values, "regionId");
            return (Criteria) this;
        }

        public Criteria andRegionIdNotIn(List<Long> values) {
            addCriterion("region_id not in", values, "regionId");
            return (Criteria) this;
        }

        public Criteria andRegionIdBetween(Long value1, Long value2) {
            addCriterion("region_id between", value1, value2, "regionId");
            return (Criteria) this;
        }

        public Criteria andRegionIdNotBetween(Long value1, Long value2) {
            addCriterion("region_id not between", value1, value2, "regionId");
            return (Criteria) this;
        }

        public Criteria andRegionCodeIsNull() {
            addCriterion("region_code is null");
            return (Criteria) this;
        }

        public Criteria andRegionCodeIsNotNull() {
            addCriterion("region_code is not null");
            return (Criteria) this;
        }

        public Criteria andRegionCodeEqualTo(String value) {
            addCriterion("region_code =", value, "regionCode");
            return (Criteria) this;
        }

        public Criteria andRegionCodeNotEqualTo(String value) {
            addCriterion("region_code <>", value, "regionCode");
            return (Criteria) this;
        }

        public Criteria andRegionCodeGreaterThan(String value) {
            addCriterion("region_code >", value, "regionCode");
            return (Criteria) this;
        }

        public Criteria andRegionCodeGreaterThanOrEqualTo(String value) {
            addCriterion("region_code >=", value, "regionCode");
            return (Criteria) this;
        }

        public Criteria andRegionCodeLessThan(String value) {
            addCriterion("region_code <", value, "regionCode");
            return (Criteria) this;
        }

        public Criteria andRegionCodeLessThanOrEqualTo(String value) {
            addCriterion("region_code <=", value, "regionCode");
            return (Criteria) this;
        }

        public Criteria andRegionCodeLike(String value) {
            addCriterion("region_code like", value, "regionCode");
            return (Criteria) this;
        }

        public Criteria andRegionCodeNotLike(String value) {
            addCriterion("region_code not like", value, "regionCode");
            return (Criteria) this;
        }

        public Criteria andRegionCodeIn(List<String> values) {
            addCriterion("region_code in", values, "regionCode");
            return (Criteria) this;
        }

        public Criteria andRegionCodeNotIn(List<String> values) {
            addCriterion("region_code not in", values, "regionCode");
            return (Criteria) this;
        }

        public Criteria andRegionCodeBetween(String value1, String value2) {
            addCriterion("region_code between", value1, value2, "regionCode");
            return (Criteria) this;
        }

        public Criteria andRegionCodeNotBetween(String value1, String value2) {
            addCriterion("region_code not between", value1, value2, "regionCode");
            return (Criteria) this;
        }

        public Criteria andLakeTypeIsNull() {
            addCriterion("lake_type is null");
            return (Criteria) this;
        }

        public Criteria andLakeTypeIsNotNull() {
            addCriterion("lake_type is not null");
            return (Criteria) this;
        }

        public Criteria andLakeTypeEqualTo(String value) {
            addCriterion("lake_type =", value, "lakeType");
            return (Criteria) this;
        }

        public Criteria andLakeTypeNotEqualTo(String value) {
            addCriterion("lake_type <>", value, "lakeType");
            return (Criteria) this;
        }

        public Criteria andLakeTypeGreaterThan(String value) {
            addCriterion("lake_type >", value, "lakeType");
            return (Criteria) this;
        }

        public Criteria andLakeTypeGreaterThanOrEqualTo(String value) {
            addCriterion("lake_type >=", value, "lakeType");
            return (Criteria) this;
        }

        public Criteria andLakeTypeLessThan(String value) {
            addCriterion("lake_type <", value, "lakeType");
            return (Criteria) this;
        }

        public Criteria andLakeTypeLessThanOrEqualTo(String value) {
            addCriterion("lake_type <=", value, "lakeType");
            return (Criteria) this;
        }

        public Criteria andLakeTypeLike(String value) {
            addCriterion("lake_type like", value, "lakeType");
            return (Criteria) this;
        }

        public Criteria andLakeTypeNotLike(String value) {
            addCriterion("lake_type not like", value, "lakeType");
            return (Criteria) this;
        }

        public Criteria andLakeTypeIn(List<String> values) {
            addCriterion("lake_type in", values, "lakeType");
            return (Criteria) this;
        }

        public Criteria andLakeTypeNotIn(List<String> values) {
            addCriterion("lake_type not in", values, "lakeType");
            return (Criteria) this;
        }

        public Criteria andLakeTypeBetween(String value1, String value2) {
            addCriterion("lake_type between", value1, value2, "lakeType");
            return (Criteria) this;
        }

        public Criteria andLakeTypeNotBetween(String value1, String value2) {
            addCriterion("lake_type not between", value1, value2, "lakeType");
            return (Criteria) this;
        }

        public Criteria andLakeNameIsNull() {
            addCriterion("lake_name is null");
            return (Criteria) this;
        }

        public Criteria andLakeNameIsNotNull() {
            addCriterion("lake_name is not null");
            return (Criteria) this;
        }

        public Criteria andLakeNameEqualTo(String value) {
            addCriterion("lake_name =", value, "lakeName");
            return (Criteria) this;
        }

        public Criteria andLakeNameNotEqualTo(String value) {
            addCriterion("lake_name <>", value, "lakeName");
            return (Criteria) this;
        }

        public Criteria andLakeNameGreaterThan(String value) {
            addCriterion("lake_name >", value, "lakeName");
            return (Criteria) this;
        }

        public Criteria andLakeNameGreaterThanOrEqualTo(String value) {
            addCriterion("lake_name >=", value, "lakeName");
            return (Criteria) this;
        }

        public Criteria andLakeNameLessThan(String value) {
            addCriterion("lake_name <", value, "lakeName");
            return (Criteria) this;
        }

        public Criteria andLakeNameLessThanOrEqualTo(String value) {
            addCriterion("lake_name <=", value, "lakeName");
            return (Criteria) this;
        }

        public Criteria andLakeNameLike(String value) {
            addCriterion("lake_name like", value, "lakeName");
            return (Criteria) this;
        }

        public Criteria andLakeNameNotLike(String value) {
            addCriterion("lake_name not like", value, "lakeName");
            return (Criteria) this;
        }

        public Criteria andLakeNameIn(List<String> values) {
            addCriterion("lake_name in", values, "lakeName");
            return (Criteria) this;
        }

        public Criteria andLakeNameNotIn(List<String> values) {
            addCriterion("lake_name not in", values, "lakeName");
            return (Criteria) this;
        }

        public Criteria andLakeNameBetween(String value1, String value2) {
            addCriterion("lake_name between", value1, value2, "lakeName");
            return (Criteria) this;
        }

        public Criteria andLakeNameNotBetween(String value1, String value2) {
            addCriterion("lake_name not between", value1, value2, "lakeName");
            return (Criteria) this;
        }

        public Criteria andLakeCodeIsNull() {
            addCriterion("lake_code is null");
            return (Criteria) this;
        }

        public Criteria andLakeCodeIsNotNull() {
            addCriterion("lake_code is not null");
            return (Criteria) this;
        }

        public Criteria andLakeCodeEqualTo(String value) {
            addCriterion("lake_code =", value, "lakeCode");
            return (Criteria) this;
        }

        public Criteria andLakeCodeNotEqualTo(String value) {
            addCriterion("lake_code <>", value, "lakeCode");
            return (Criteria) this;
        }

        public Criteria andLakeCodeGreaterThan(String value) {
            addCriterion("lake_code >", value, "lakeCode");
            return (Criteria) this;
        }

        public Criteria andLakeCodeGreaterThanOrEqualTo(String value) {
            addCriterion("lake_code >=", value, "lakeCode");
            return (Criteria) this;
        }

        public Criteria andLakeCodeLessThan(String value) {
            addCriterion("lake_code <", value, "lakeCode");
            return (Criteria) this;
        }

        public Criteria andLakeCodeLessThanOrEqualTo(String value) {
            addCriterion("lake_code <=", value, "lakeCode");
            return (Criteria) this;
        }

        public Criteria andLakeCodeLike(String value) {
            addCriterion("lake_code like", value, "lakeCode");
            return (Criteria) this;
        }

        public Criteria andLakeCodeNotLike(String value) {
            addCriterion("lake_code not like", value, "lakeCode");
            return (Criteria) this;
        }

        public Criteria andLakeCodeIn(List<String> values) {
            addCriterion("lake_code in", values, "lakeCode");
            return (Criteria) this;
        }

        public Criteria andLakeCodeNotIn(List<String> values) {
            addCriterion("lake_code not in", values, "lakeCode");
            return (Criteria) this;
        }

        public Criteria andLakeCodeBetween(String value1, String value2) {
            addCriterion("lake_code between", value1, value2, "lakeCode");
            return (Criteria) this;
        }

        public Criteria andLakeCodeNotBetween(String value1, String value2) {
            addCriterion("lake_code not between", value1, value2, "lakeCode");
            return (Criteria) this;
        }

        public Criteria andLakeDescriptionIsNull() {
            addCriterion("lake_description is null");
            return (Criteria) this;
        }

        public Criteria andLakeDescriptionIsNotNull() {
            addCriterion("lake_description is not null");
            return (Criteria) this;
        }

        public Criteria andLakeDescriptionEqualTo(String value) {
            addCriterion("lake_description =", value, "lakeDescription");
            return (Criteria) this;
        }

        public Criteria andLakeDescriptionNotEqualTo(String value) {
            addCriterion("lake_description <>", value, "lakeDescription");
            return (Criteria) this;
        }

        public Criteria andLakeDescriptionGreaterThan(String value) {
            addCriterion("lake_description >", value, "lakeDescription");
            return (Criteria) this;
        }

        public Criteria andLakeDescriptionGreaterThanOrEqualTo(String value) {
            addCriterion("lake_description >=", value, "lakeDescription");
            return (Criteria) this;
        }

        public Criteria andLakeDescriptionLessThan(String value) {
            addCriterion("lake_description <", value, "lakeDescription");
            return (Criteria) this;
        }

        public Criteria andLakeDescriptionLessThanOrEqualTo(String value) {
            addCriterion("lake_description <=", value, "lakeDescription");
            return (Criteria) this;
        }

        public Criteria andLakeDescriptionLike(String value) {
            addCriterion("lake_description like", value, "lakeDescription");
            return (Criteria) this;
        }

        public Criteria andLakeDescriptionNotLike(String value) {
            addCriterion("lake_description not like", value, "lakeDescription");
            return (Criteria) this;
        }

        public Criteria andLakeDescriptionIn(List<String> values) {
            addCriterion("lake_description in", values, "lakeDescription");
            return (Criteria) this;
        }

        public Criteria andLakeDescriptionNotIn(List<String> values) {
            addCriterion("lake_description not in", values, "lakeDescription");
            return (Criteria) this;
        }

        public Criteria andLakeDescriptionBetween(String value1, String value2) {
            addCriterion("lake_description between", value1, value2, "lakeDescription");
            return (Criteria) this;
        }

        public Criteria andLakeDescriptionNotBetween(String value1, String value2) {
            addCriterion("lake_description not between", value1, value2, "lakeDescription");
            return (Criteria) this;
        }

        public Criteria andLakeAreaIsNull() {
            addCriterion("lake_area is null");
            return (Criteria) this;
        }

        public Criteria andLakeAreaIsNotNull() {
            addCriterion("lake_area is not null");
            return (Criteria) this;
        }

        public Criteria andLakeAreaEqualTo(BigDecimal value) {
            addCriterion("lake_area =", value, "lakeArea");
            return (Criteria) this;
        }

        public Criteria andLakeAreaNotEqualTo(BigDecimal value) {
            addCriterion("lake_area <>", value, "lakeArea");
            return (Criteria) this;
        }

        public Criteria andLakeAreaGreaterThan(BigDecimal value) {
            addCriterion("lake_area >", value, "lakeArea");
            return (Criteria) this;
        }

        public Criteria andLakeAreaGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("lake_area >=", value, "lakeArea");
            return (Criteria) this;
        }

        public Criteria andLakeAreaLessThan(BigDecimal value) {
            addCriterion("lake_area <", value, "lakeArea");
            return (Criteria) this;
        }

        public Criteria andLakeAreaLessThanOrEqualTo(BigDecimal value) {
            addCriterion("lake_area <=", value, "lakeArea");
            return (Criteria) this;
        }

        public Criteria andLakeAreaIn(List<BigDecimal> values) {
            addCriterion("lake_area in", values, "lakeArea");
            return (Criteria) this;
        }

        public Criteria andLakeAreaNotIn(List<BigDecimal> values) {
            addCriterion("lake_area not in", values, "lakeArea");
            return (Criteria) this;
        }

        public Criteria andLakeAreaBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("lake_area between", value1, value2, "lakeArea");
            return (Criteria) this;
        }

        public Criteria andLakeAreaNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("lake_area not between", value1, value2, "lakeArea");
            return (Criteria) this;
        }

        public Criteria andLakeImpoundageIsNull() {
            addCriterion("lake_impoundage is null");
            return (Criteria) this;
        }

        public Criteria andLakeImpoundageIsNotNull() {
            addCriterion("lake_impoundage is not null");
            return (Criteria) this;
        }

        public Criteria andLakeImpoundageEqualTo(BigDecimal value) {
            addCriterion("lake_impoundage =", value, "lakeImpoundage");
            return (Criteria) this;
        }

        public Criteria andLakeImpoundageNotEqualTo(BigDecimal value) {
            addCriterion("lake_impoundage <>", value, "lakeImpoundage");
            return (Criteria) this;
        }

        public Criteria andLakeImpoundageGreaterThan(BigDecimal value) {
            addCriterion("lake_impoundage >", value, "lakeImpoundage");
            return (Criteria) this;
        }

        public Criteria andLakeImpoundageGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("lake_impoundage >=", value, "lakeImpoundage");
            return (Criteria) this;
        }

        public Criteria andLakeImpoundageLessThan(BigDecimal value) {
            addCriterion("lake_impoundage <", value, "lakeImpoundage");
            return (Criteria) this;
        }

        public Criteria andLakeImpoundageLessThanOrEqualTo(BigDecimal value) {
            addCriterion("lake_impoundage <=", value, "lakeImpoundage");
            return (Criteria) this;
        }

        public Criteria andLakeImpoundageIn(List<BigDecimal> values) {
            addCriterion("lake_impoundage in", values, "lakeImpoundage");
            return (Criteria) this;
        }

        public Criteria andLakeImpoundageNotIn(List<BigDecimal> values) {
            addCriterion("lake_impoundage not in", values, "lakeImpoundage");
            return (Criteria) this;
        }

        public Criteria andLakeImpoundageBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("lake_impoundage between", value1, value2, "lakeImpoundage");
            return (Criteria) this;
        }

        public Criteria andLakeImpoundageNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("lake_impoundage not between", value1, value2, "lakeImpoundage");
            return (Criteria) this;
        }

        public Criteria andLakeChiefIsNull() {
            addCriterion("lake_chief is null");
            return (Criteria) this;
        }

        public Criteria andLakeChiefIsNotNull() {
            addCriterion("lake_chief is not null");
            return (Criteria) this;
        }

        public Criteria andLakeChiefEqualTo(String value) {
            addCriterion("lake_chief =", value, "lakeChief");
            return (Criteria) this;
        }

        public Criteria andLakeChiefNotEqualTo(String value) {
            addCriterion("lake_chief <>", value, "lakeChief");
            return (Criteria) this;
        }

        public Criteria andLakeChiefGreaterThan(String value) {
            addCriterion("lake_chief >", value, "lakeChief");
            return (Criteria) this;
        }

        public Criteria andLakeChiefGreaterThanOrEqualTo(String value) {
            addCriterion("lake_chief >=", value, "lakeChief");
            return (Criteria) this;
        }

        public Criteria andLakeChiefLessThan(String value) {
            addCriterion("lake_chief <", value, "lakeChief");
            return (Criteria) this;
        }

        public Criteria andLakeChiefLessThanOrEqualTo(String value) {
            addCriterion("lake_chief <=", value, "lakeChief");
            return (Criteria) this;
        }

        public Criteria andLakeChiefLike(String value) {
            addCriterion("lake_chief like", value, "lakeChief");
            return (Criteria) this;
        }

        public Criteria andLakeChiefNotLike(String value) {
            addCriterion("lake_chief not like", value, "lakeChief");
            return (Criteria) this;
        }

        public Criteria andLakeChiefIn(List<String> values) {
            addCriterion("lake_chief in", values, "lakeChief");
            return (Criteria) this;
        }

        public Criteria andLakeChiefNotIn(List<String> values) {
            addCriterion("lake_chief not in", values, "lakeChief");
            return (Criteria) this;
        }

        public Criteria andLakeChiefBetween(String value1, String value2) {
            addCriterion("lake_chief between", value1, value2, "lakeChief");
            return (Criteria) this;
        }

        public Criteria andLakeChiefNotBetween(String value1, String value2) {
            addCriterion("lake_chief not between", value1, value2, "lakeChief");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNormalIsNull() {
            addCriterion("water_level_normal is null");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNormalIsNotNull() {
            addCriterion("water_level_normal is not null");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNormalEqualTo(BigDecimal value) {
            addCriterion("water_level_normal =", value, "waterLevelNormal");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNormalNotEqualTo(BigDecimal value) {
            addCriterion("water_level_normal <>", value, "waterLevelNormal");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNormalGreaterThan(BigDecimal value) {
            addCriterion("water_level_normal >", value, "waterLevelNormal");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNormalGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("water_level_normal >=", value, "waterLevelNormal");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNormalLessThan(BigDecimal value) {
            addCriterion("water_level_normal <", value, "waterLevelNormal");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNormalLessThanOrEqualTo(BigDecimal value) {
            addCriterion("water_level_normal <=", value, "waterLevelNormal");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNormalIn(List<BigDecimal> values) {
            addCriterion("water_level_normal in", values, "waterLevelNormal");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNormalNotIn(List<BigDecimal> values) {
            addCriterion("water_level_normal not in", values, "waterLevelNormal");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNormalBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("water_level_normal between", value1, value2, "waterLevelNormal");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNormalNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("water_level_normal not between", value1, value2, "waterLevelNormal");
            return (Criteria) this;
        }

        public Criteria andWaterLevelWarningIsNull() {
            addCriterion("water_level_warning is null");
            return (Criteria) this;
        }

        public Criteria andWaterLevelWarningIsNotNull() {
            addCriterion("water_level_warning is not null");
            return (Criteria) this;
        }

        public Criteria andWaterLevelWarningEqualTo(BigDecimal value) {
            addCriterion("water_level_warning =", value, "waterLevelWarning");
            return (Criteria) this;
        }

        public Criteria andWaterLevelWarningNotEqualTo(BigDecimal value) {
            addCriterion("water_level_warning <>", value, "waterLevelWarning");
            return (Criteria) this;
        }

        public Criteria andWaterLevelWarningGreaterThan(BigDecimal value) {
            addCriterion("water_level_warning >", value, "waterLevelWarning");
            return (Criteria) this;
        }

        public Criteria andWaterLevelWarningGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("water_level_warning >=", value, "waterLevelWarning");
            return (Criteria) this;
        }

        public Criteria andWaterLevelWarningLessThan(BigDecimal value) {
            addCriterion("water_level_warning <", value, "waterLevelWarning");
            return (Criteria) this;
        }

        public Criteria andWaterLevelWarningLessThanOrEqualTo(BigDecimal value) {
            addCriterion("water_level_warning <=", value, "waterLevelWarning");
            return (Criteria) this;
        }

        public Criteria andWaterLevelWarningIn(List<BigDecimal> values) {
            addCriterion("water_level_warning in", values, "waterLevelWarning");
            return (Criteria) this;
        }

        public Criteria andWaterLevelWarningNotIn(List<BigDecimal> values) {
            addCriterion("water_level_warning not in", values, "waterLevelWarning");
            return (Criteria) this;
        }

        public Criteria andWaterLevelWarningBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("water_level_warning between", value1, value2, "waterLevelWarning");
            return (Criteria) this;
        }

        public Criteria andWaterLevelWarningNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("water_level_warning not between", value1, value2, "waterLevelWarning");
            return (Criteria) this;
        }

        public Criteria andWaterLevelDeadIsNull() {
            addCriterion("water_level_dead is null");
            return (Criteria) this;
        }

        public Criteria andWaterLevelDeadIsNotNull() {
            addCriterion("water_level_dead is not null");
            return (Criteria) this;
        }

        public Criteria andWaterLevelDeadEqualTo(BigDecimal value) {
            addCriterion("water_level_dead =", value, "waterLevelDead");
            return (Criteria) this;
        }

        public Criteria andWaterLevelDeadNotEqualTo(BigDecimal value) {
            addCriterion("water_level_dead <>", value, "waterLevelDead");
            return (Criteria) this;
        }

        public Criteria andWaterLevelDeadGreaterThan(BigDecimal value) {
            addCriterion("water_level_dead >", value, "waterLevelDead");
            return (Criteria) this;
        }

        public Criteria andWaterLevelDeadGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("water_level_dead >=", value, "waterLevelDead");
            return (Criteria) this;
        }

        public Criteria andWaterLevelDeadLessThan(BigDecimal value) {
            addCriterion("water_level_dead <", value, "waterLevelDead");
            return (Criteria) this;
        }

        public Criteria andWaterLevelDeadLessThanOrEqualTo(BigDecimal value) {
            addCriterion("water_level_dead <=", value, "waterLevelDead");
            return (Criteria) this;
        }

        public Criteria andWaterLevelDeadIn(List<BigDecimal> values) {
            addCriterion("water_level_dead in", values, "waterLevelDead");
            return (Criteria) this;
        }

        public Criteria andWaterLevelDeadNotIn(List<BigDecimal> values) {
            addCriterion("water_level_dead not in", values, "waterLevelDead");
            return (Criteria) this;
        }

        public Criteria andWaterLevelDeadBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("water_level_dead between", value1, value2, "waterLevelDead");
            return (Criteria) this;
        }

        public Criteria andWaterLevelDeadNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("water_level_dead not between", value1, value2, "waterLevelDead");
            return (Criteria) this;
        }

        public Criteria andWaterQualityIsNull() {
            addCriterion("water_quality is null");
            return (Criteria) this;
        }

        public Criteria andWaterQualityIsNotNull() {
            addCriterion("water_quality is not null");
            return (Criteria) this;
        }

        public Criteria andWaterQualityEqualTo(String value) {
            addCriterion("water_quality =", value, "waterQuality");
            return (Criteria) this;
        }

        public Criteria andWaterQualityNotEqualTo(String value) {
            addCriterion("water_quality <>", value, "waterQuality");
            return (Criteria) this;
        }

        public Criteria andWaterQualityGreaterThan(String value) {
            addCriterion("water_quality >", value, "waterQuality");
            return (Criteria) this;
        }

        public Criteria andWaterQualityGreaterThanOrEqualTo(String value) {
            addCriterion("water_quality >=", value, "waterQuality");
            return (Criteria) this;
        }

        public Criteria andWaterQualityLessThan(String value) {
            addCriterion("water_quality <", value, "waterQuality");
            return (Criteria) this;
        }

        public Criteria andWaterQualityLessThanOrEqualTo(String value) {
            addCriterion("water_quality <=", value, "waterQuality");
            return (Criteria) this;
        }

        public Criteria andWaterQualityLike(String value) {
            addCriterion("water_quality like", value, "waterQuality");
            return (Criteria) this;
        }

        public Criteria andWaterQualityNotLike(String value) {
            addCriterion("water_quality not like", value, "waterQuality");
            return (Criteria) this;
        }

        public Criteria andWaterQualityIn(List<String> values) {
            addCriterion("water_quality in", values, "waterQuality");
            return (Criteria) this;
        }

        public Criteria andWaterQualityNotIn(List<String> values) {
            addCriterion("water_quality not in", values, "waterQuality");
            return (Criteria) this;
        }

        public Criteria andWaterQualityBetween(String value1, String value2) {
            addCriterion("water_quality between", value1, value2, "waterQuality");
            return (Criteria) this;
        }

        public Criteria andWaterQualityNotBetween(String value1, String value2) {
            addCriterion("water_quality not between", value1, value2, "waterQuality");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNull() {
            addCriterion("remark is null");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNotNull() {
            addCriterion("remark is not null");
            return (Criteria) this;
        }

        public Criteria andRemarkEqualTo(String value) {
            addCriterion("remark =", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotEqualTo(String value) {
            addCriterion("remark <>", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThan(String value) {
            addCriterion("remark >", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThanOrEqualTo(String value) {
            addCriterion("remark >=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThan(String value) {
            addCriterion("remark <", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThanOrEqualTo(String value) {
            addCriterion("remark <=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLike(String value) {
            addCriterion("remark like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotLike(String value) {
            addCriterion("remark not like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkIn(List<String> values) {
            addCriterion("remark in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotIn(List<String> values) {
            addCriterion("remark not in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkBetween(String value1, String value2) {
            addCriterion("remark between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotBetween(String value1, String value2) {
            addCriterion("remark not between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNull() {
            addCriterion("created_at is null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNotNull() {
            addCriterion("created_at is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtEqualTo(Date value) {
            addCriterion("created_at =", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotEqualTo(Date value) {
            addCriterion("created_at <>", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThan(Date value) {
            addCriterion("created_at >", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("created_at >=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThan(Date value) {
            addCriterion("created_at <", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThanOrEqualTo(Date value) {
            addCriterion("created_at <=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIn(List<Date> values) {
            addCriterion("created_at in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotIn(List<Date> values) {
            addCriterion("created_at not in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtBetween(Date value1, Date value2) {
            addCriterion("created_at between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotBetween(Date value1, Date value2) {
            addCriterion("created_at not between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNull() {
            addCriterion("created_by is null");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNotNull() {
            addCriterion("created_by is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedByEqualTo(String value) {
            addCriterion("created_by =", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotEqualTo(String value) {
            addCriterion("created_by <>", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThan(String value) {
            addCriterion("created_by >", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThanOrEqualTo(String value) {
            addCriterion("created_by >=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThan(String value) {
            addCriterion("created_by <", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThanOrEqualTo(String value) {
            addCriterion("created_by <=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLike(String value) {
            addCriterion("created_by like", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotLike(String value) {
            addCriterion("created_by not like", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByIn(List<String> values) {
            addCriterion("created_by in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotIn(List<String> values) {
            addCriterion("created_by not in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByBetween(String value1, String value2) {
            addCriterion("created_by between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotBetween(String value1, String value2) {
            addCriterion("created_by not between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIsNull() {
            addCriterion("deleted_at is null");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIsNotNull() {
            addCriterion("deleted_at is not null");
            return (Criteria) this;
        }

        public Criteria andDeletedAtEqualTo(Date value) {
            addCriterion("deleted_at =", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotEqualTo(Date value) {
            addCriterion("deleted_at <>", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtGreaterThan(Date value) {
            addCriterion("deleted_at >", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("deleted_at >=", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtLessThan(Date value) {
            addCriterion("deleted_at <", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtLessThanOrEqualTo(Date value) {
            addCriterion("deleted_at <=", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIn(List<Date> values) {
            addCriterion("deleted_at in", values, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotIn(List<Date> values) {
            addCriterion("deleted_at not in", values, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtBetween(Date value1, Date value2) {
            addCriterion("deleted_at between", value1, value2, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotBetween(Date value1, Date value2) {
            addCriterion("deleted_at not between", value1, value2, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedByIsNull() {
            addCriterion("deleted_by is null");
            return (Criteria) this;
        }

        public Criteria andDeletedByIsNotNull() {
            addCriterion("deleted_by is not null");
            return (Criteria) this;
        }

        public Criteria andDeletedByEqualTo(String value) {
            addCriterion("deleted_by =", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotEqualTo(String value) {
            addCriterion("deleted_by <>", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByGreaterThan(String value) {
            addCriterion("deleted_by >", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByGreaterThanOrEqualTo(String value) {
            addCriterion("deleted_by >=", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByLessThan(String value) {
            addCriterion("deleted_by <", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByLessThanOrEqualTo(String value) {
            addCriterion("deleted_by <=", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByLike(String value) {
            addCriterion("deleted_by like", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotLike(String value) {
            addCriterion("deleted_by not like", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByIn(List<String> values) {
            addCriterion("deleted_by in", values, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotIn(List<String> values) {
            addCriterion("deleted_by not in", values, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByBetween(String value1, String value2) {
            addCriterion("deleted_by between", value1, value2, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotBetween(String value1, String value2) {
            addCriterion("deleted_by not between", value1, value2, "deletedBy");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}